#include "sound.h"
#include "math.h"

typedef struct {
	SAMPLE *sdata;
  WORD offset,rlength,end;
  signed char volume,volume2;
  WORD sample_number;
  DWORD position;
	WORD counter,pinc;
  BYTE effect,x,y;
  int data1,data2,data3,data4;
	long count,porta;
	BYTE retrigger,cut;
  WORD period,period2,vibdepth,vibperiod;
  int vslide;
} CHANNEL;

typedef struct {
	char title[20];
  char sample_name[32][22];
  DWORD slength[32],offset[32],repeat[32];
  signed char finetune[32];
  BYTE volume[32],num_positions,maxpattern,ptable[128],sig[5];
  BYTE far *pattern_data[128];
	BYTE num_samples;
  SAMPLE *sdata[32];
} MOD;

void far interrupt mod_int(void);
void far interrupt mod_int2(void);
MOD *loadmod(char *modfilename);
void freemod(MOD *freeme);


extern MOD *mod_data;
extern int mod_on,mod_reset,mod_tablepos,mod_currenttick;
extern int mod_bytespertick ,mod_ticksperdivision;

extern CHANNEL chan[4];
extern BYTE channel_select[4];

