#include <stdio.h>
#include <conio.h>
#include "svgacc.h"
#include "sound.h"

void testmix();

																/* function prototpes */

extern int sounds_in_queue;
extern int midi_callfreq;
extern long int debugnum;
extern dma_bufferlen;

main()
{
	int i,j,k;
  int mouse,videocard,vmode;
  RGB palette[256];
  RasterBlock far *blk;
  char r = 'r';

  blk = (RasterBlock *)farmalloc(15000);
  if(!blk) exit(0);

  clrscr();

  SBSetUp();
  //videocard = whichvga();           // Initialize graphics
  //res640();                         // Select 800x600x256 resolution.
  //mouse = whichmouse();             // initialize mouse

  while(r != 'q') {
  	for(i = 0; i < 100; i++) *(blk->data+i) = i;
  	testmix(blk->data+3);
    for(i = 0; i < 15; i++) printf("%d, ",*(blk->data+i));
    r = getch();
  }
}



/**************************************************************************
	void testmix(void)

                                   // *                                 *
                                   // *       Mix in plain sounds       *
                                   // *                                 *
                                   // ***********************************
  s = soundlist;
  while(s){
		hold = s->next;
    if(s->active && s->type == v_plain) {
      if(*s->pos >= dma_bufferlen) {// enough left to fill the buffer?
        for(j = 0; j < dma_bufferlen; j++) *(mix_buffer+j) += *(s->data++);
        *s->pos -= (dma_bufferlen);
      }
      else {                         // else play what is left
        for(j = 0; j <= *s->pos; j++) *(mix_buffer+j) += *(s->data++);

        if(s->chain) {               // Is there a sound to play after this?
        	(s->chain)->next = soundlist;
          soundlist = s->chain;
          s->chain = NULL;					 // Break link to hide from freesound()
          sounds_in_queue++;
        }
        freesound(s->id);            // delete the sound
      }
    }
    DOSYNC;
    s = hold;
  }
  DOSYNC;

  																 // ***********************************
                                   // *                                 *
                                   // *      Mix in fancy sounds        *
                                   // *                                 *
                                   // ***********************************
  s = soundlist;
  while(s){
		hold = s->next;
    if(s->active && s->type == v_fancy) {
      for(j = 0; j < dma_bufferlen; j++) {
                               			// Add this byte to the mixing buffer
        *(mix_buffer+j) += (*(s->data + *s->pos) * s->volume)>>4;
                               			// Here is where the frequency magic
                               			// happens.  I use fixed point arithmatic
                               			// to increment the sample position pointer
                               			// at different rates.
        s->position += s->pinc;
                               			// Are we at the end of the sample?
        if(*s->pos >= s->length) {
        	if(!s->repeat) {          // Do we not repeat this sample?

            if(s->chain) {          // Is there an effect to play after this?
        	    (s->chain)->next = soundlist;
              soundlist = s->chain;
          		s->chain = NULL;			// Break link to hide from freesound()
              sounds_in_queue++;
            }

				  	freesound(s->id);      // Terminate it if not.
          	break;
          }
          else {                    // Decrememnt the repeat counter
          	if(s->repeat > 0) s->repeat--; // -1 = infinity
            s->position = 0;
          }
        }
      }
    }
    DOSYNC;
    s = hold;
  }
  DOSYNC;

**************************************************************************/
void testmix(BYTE far *buffer)
{
	int j;
	WORD t,off1,seg1,off2,seg2;
  BYTE *newbuf = {" "};

  off2 = FP_OFF(buffer);
  seg2 = FP_SEG(buffer);
  off1 = FP_OFF(newbuf);
  seg1 = FP_SEG(newbuf);

  TimerOn();
  asm pusha
 	_DS = seg1;
 	_ES = seg2;
  asm mov si,off1
  asm mov di,off2
	asm	mov cx,10000
loopdec:
  asm lodsb

  asm  loop loopdec
  asm popa
//	for(j = 0; j < 10000; j++) *(buffer+j) += *(newbuf++);

  t = TimerOff();
  printf("t= %d\n",t);
}

/*  asm push ds
 	_DS = seg;
  asm  mov si,off
	asm	mov cx,10000
	asm	mov al,0
loopdec:
  asm mov [si],al
  asm inc si
  asm  loop loopdec
  asm pop ds   */
