/*************************************************************************
	WINFUNCS.C

	This contains graphics primitives for windows.c

	Written By: Eric Jorgensen (1995)
**************************************************************************/
#include "mouse.h"
#include "windows.h"
#include "graphics.h"

void VW_hidemouse(void)
{
  mousehide();
}

void VW_showmouse(void)
{
	mouseshow();
}

void VW_mousestatus(int *x, int *y, int *buttons)
{
	mousestatus(x,y,buttons);
}
//graphics.h
void VW_bar(int color,int x1,int y1,int x2,int y2)
{
	setfillstyle(1,color);
	bar(x1,y1,x2,y2);
}

void VW_line(int color,int x1,int y1,int x2,int y2)
{
	setcolor(color);
	line(x1,y1,x2,y2);
}

void VW_circle(int color,int x1,int y1, int radius)
{
	setcolor(color);
	circle(x1,y1,radius);
}

void VW_floodfill(int color,int x,int y, int border)
{
	setfillstyle(1,color);
	floodfill(x,y,border);
}

void VW_outtextxy(int color,int x, int y, char *string)
{
	setcolor(color);
	outtextxy(x,y,string);
}

int  VW_textwidth(char *foo)
{
	return (textwidth(foo));
}

int	 VW_textheight(char *foo)
{
	return (textheight(foo));
}