
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include "sound.h"
//#include "svgacc.h"
//#include <math.h>

void printmod(MOD *m,FILE *output);
void trysound(MOD *m,int s);
void timetest(void);
int mykbhit(void);
void modstepper(void);

extern int mod_tablepos,mod_currenttick;
extern BYTE mod_channelselect[];
extern long int debugnum;
extern WORD sample_rate;

extern CHANNEL chan[4];
extern  int 				mod_on,mod_reset;
extern  BYTE far 		*mod_pattern,*mod_pstop,*mod_loopspot;
extern  int 				mod_loopcount;
extern  int 				mod_bytespertick,mod_ticksperdivision;
extern  int 				mod_currentbyte;
extern  int 				mod_divoffset;
extern  int 				mod_glissando;
extern  int 				mod_finetune;
extern  int 				mod_patterndelay;

char mfn[80] = {"noname.mod"};

char *effect_primary[] = {
	"Arpeggio",
	"PortaM up",
	"PortaM down",
	"Porta NOTE",
	"Vibrato",
	"porta+vol",
	"Vib+vol",
	"Tremolo",
	"UNUSED",
	"Set offset",
  "Vol slide",
	"Postn Jmp",
	"Set Volume",
	"Pat Break",
	"special14",
  "Set Speed"};
char *effect_secondary[] = {
	"Filter T/F",
	"Finesld up",
	"Finesld dn",
	"Gliss T/F",
  "Vibr WF",
	"Finetune WF",
	"Loop Pattrn",
	"Tremolo WF",
  "UNUSED",
	"Retrigger",
	"FineVolS up",
	"FineVolS Dn",
	"Cut Sample",
  "Delay Sampl",
	"Delay Pttrn",
	"Invert Loop"};


/**************************************************************************
	main(void)

  DESCRIPTION:

**************************************************************************/
main(int argc, char *argv[])
{
	int i,j,k,x=0,y=0;
  int samp;
  WORD period;
	BYTE e1,e2,e3;
  char r=0;
  FILE *input,*output;
  BYTE *pdata;
  MOD foo;
	MOD far *mymod;
  SAMPLE *aha;
  WORD alen,tslen;
  DWORD count=0,total=0;
  double oh;
  unsigned char string[255];
  int mouse,videocard,vmode,playme = 0,cr;

  if(argc>1) strcpy(mfn,argv[1]);

  string[0] = 233; string[1] = 245;
  i = (*(string)&0xF0);
  j = (*(string+1) & 0xf0)>>4;

  clrscr();
  gotoxy(50,18);
  cr = farcoreleft()/1000L;
	//videocard = whichvga();           // Initialize graphics
	//res640();                         // Select 800x600x256 resolution.
/*	mouse = whichmouse();             // initialize mouse
  mouseenter();
  mouseshow();  */


  //printf("Enter MOD filename: ");
  //gets(mfn);
  //if(!strlen(mfn)) strcpy(mfn,"short.mod");


  SBSetUp();
  mymod = LoadMod(mfn,string);
  if(!mymod) {
  	printf("MOD error: %s \n",string);
		exit(1);
  }

  /*strcpy(string,mfn);
  for(i = 0; string[i] != '.'; i++);
  string[i] = 0;
  strcat(string,".txt");
  output = fopen(string,"w");
  printmod(mymod,output);
  fclose(output); */

  /*mod_data = mymod;
  modstepper();

  exit(1);  */
  SetSampleRate(22000);

  GoVarmint();
  for(i = 0; i < mymod->num_samples; i++) {
  	if(mymod->slength[i]) {
  		//printf("%d] l: %lu  o: %lu   r: %lu, v:%u\n",i,
			//		mymod->slength[i],mymod->offset[i],mymod->repeat[i],mymod->volume[i]);
      if(mymod->slength[i]) printf("%d] %s\n",i,mymod->sample_name[i]);
    }
  }

  DSP_overhead = 1;

  mod_data = mymod;
  ModCommand(v_play);
  gotoxy(50,22);
  printf("CORE: %uKb",cr);

	while(toupper(r) != 'Q') {
  	if(mykbhit()) {
			r = getch();
    	if(r >= '0' && r <= '9') PlaySound(mymod->sdata[r-'0'],mymod->slength[r-'0'],v_plain);
      //else if(r == 'm') mod_on ^= TRUE;
      else if(r == 'r') ModCommand(v_rewind);
      else if(r == '=') mod_tablepos++;
      else if(r == '-') mod_tablepos--;
      else if(r == '!') mod_channelselect[0] ^= 1;
      else if(r == '@') mod_channelselect[1] ^= 1;
      else if(r == '#') mod_channelselect[2] ^= 1;
      else if(r == '$') mod_channelselect[3] ^= 1;
      else if(r == 'z') playme--;
      else if(r == 'x') playme++;
      else if(r == 'l') mod_bytespertick+=50;
      else if(r == ' ') PlaySound(mymod->sdata[playme],mymod->slength[playme],v_plain);
      else if(r == 's') {
        strcpy(string,mfn);
        for(i = 0; string[i] != '.'; i++);
        string[i] = 0;
        strcat(string,".txt");
        output = fopen(string,"w");
        printmod(mymod,output);
        fclose(output);
      }

      else if(r == ' ') {
        y = 0;
      }


    }
    k = vclock;

    //while(k == vclock);
    gotoxy(40,2);
    printf("Tick: %d  Tablepos: %d  ",mod_currenttick,mod_tablepos);
    for(i = 0; i < 4; i++) {
    	gotoxy(40,4+i);
      printf("CHANNEL%d:",i);
      if(chan[i].volume && chan[i].position <= chan[i].end) {
      	if(chan[i].effect != 14) printf("%s       ",effect_primary[chan[i].effect]);
      	else printf("%s (E)      ",effect_secondary[chan[i].x]);
      }
      //else printf("                        ");
      gotoxy(70,1);
      printf("%d%d%d%d",mod_channelselect[0],mod_channelselect[1],
											 mod_channelselect[2],mod_channelselect[3]);
    }
    for(i = 0; i < 4; i++) {
    	gotoxy(40,9+i);
      printf("CHANNEL%d: ",i);
    	printf("%d\t%d\t%d         ",chan[i].sample_number,chan[i].pinc,chan[i].volume);
    }
    gotoxy(40,1);
    printf("Debug: %d   ",debugnum);
    gotoxy(60,1);
    printf("%d  ",playme);
    count++;
    total+=DSP_overhead;
    if(count == 20) {
    	oh = PercentOverhead(count/20)/10.0;
      gotoxy(40,14);
			printf("Overhead: %.2lf",oh);
      total = 0;
      count = 0;
    }
  }

  DropDeadVarmint();
  ///restext();
  FreeMod(mymod);
  printf("\nCORE: %luKb",farcoreleft()/1000L);

  return 0;
}



/**************************************************************************
	int mykbhit(void)

  DESCRIPTION: My own keystroke detection function

**************************************************************************/
int mykbhit(void)
{
 	asm mov ah,0x01
  asm int 0x16
	return(!(_FLAGS &0x40));
}


/**************************************************************************
	void timetest(void)

  DESCRIPTION:

**************************************************************************/
void timetest(void)
{
	int d,i,j,k,mixbuf[100],*mbuf;
  BYTE databuf[100];
	SAMPLE *sound[10];
  WORD slen[10],spos[10],dma_pos,t;

  for (i = 0; i <10; i++) {
		sound[i] = (SAMPLE *)farmalloc(5);
    slen[i] = 10000;
    spos[i] = 10000;
  }

  TimerOn();
  for(dma_pos = 0; dma_pos < 100; dma_pos++) {
  	d = 128;                       // reset data holder

    for(i = 0; i < 10; i++) {
  	  d += *(sound[i]++);  		 // accumulate data
      spos[i]--;         			 // move to next byte
      if(!spos[i]) {           // Sound done?
      }
    }
    if(d>255) d = 255;             // clip the output byte
    if(d<0) d = 0;

    *(databuf + dma_pos) = d;   // Write data to the buffer
  }
  t = TimerOff();

  printf("Old ticks: %u\n",t);


  TimerOn();
  for(j = 0; j < 100; j++) *(mixbuf+j) = 0;

  for(i = 0; i <10; i++) {
  	if(spos[i]>100) {
    	for(j = 0; j < 100; j++) *(mixbuf+j) += *(sound[i]++);
    }
    else printf("whhooopppsss");

    spos[i] -= 100;
  }

  for(mbuf = mixbuf,j=0; mbuf < mixbuf+100; mbuf++,j++) {
		if(*mbuf > 255) *mbuf = 255;
		if(*mbuf < 0) *mbuf = 0;
    *(databuf +j ) = *mbuf;
  }

  t = TimerOff();

  printf("NEW ticks: %u\n",t);


}







/**************************************************************************
	void trysound(MOD *m,int s)

  DESCRIPTION:

**************************************************************************/
void trysound(MOD *m,int s)
{
	int i,j,k,status;
  WORD counter=0,inc=0,position=0,offset,rl,end;
  SAMPLE *d;

  status = bioskey(2);

  inc = 256;
  end = m->slength[s]*2;
  d = m->sdata[s];
  rl = m->repeat[s]*2;
  if(rl ==2) rl = 0;
  offset = m->offset[s]*2;


  while(!(status & 0x03)) {
  	status = bioskey(2);

    DSPWrite(0x10);
    DSPWrite(*(d+position)+128);
    mdelay(600);

    counter += inc;
		position += counter>>8;
    counter &= 0x00ff;

    if(position >= end) {
      if(rl > 1) {
        position = offset;
        counter = 0;
        end = offset + rl;
      }
      else return;
    }

	}
}





/**************************************************************************
	void prinmod(void)

  DESCRIPTION:

	char title[20];
  char sample_name[32][22];
  DWORD slength[32],offset[32],repeat[32];
  BYTE finetune[32],volume[32],num_positions,maxpattern,ptable[128],sig[5];
  BYTE far *pattern_data[128];
	BYTE num_samples;
  SAMPLE *sdata[32];

**************************************************************************/
void printmod(MOD *m,FILE *output)
{
	int i,j,k,l,line = 0;
  int samp;
  WORD period,rate;
	BYTE e1,e2,e3,byte;
	BYTE far *data;
  float num;
  char hexchar[16] = {"0123456789ABCDEF"},string[255];


  fprintf(output,"Ouput file for: %s\n",mfn);
  fprintf(output,"-------------------------\nTITLE: %s\n",m->title);
	for(i = 0; i < m->num_samples;i++) {
  	fprintf(output,"Voice #%d: %s [%u %u %u]\n",i,m->sample_name[i],
    						m->slength[i],m->offset[i],m->repeat[i]);
  }
  fprintf(output,"\n");

  for(j = 0 ; j < m->num_positions; j++) {
  	fprintf(output,"\n------------------ DIVISION: %d ------------------ ",j);
		fprintf(output,"%s --------------------------------------------\n\n",mfn);
  	data = m->pattern_data[m->ptable[j]];
    for(l = 0; l < 64; l++) {
      sprintf(string,"%d]",line);
      fprintf(output,string);
      for(k = 0; k < 6-strlen(string); k++) fprintf(output," ");
      line++;

      for(i = 0; i < 4; i++) {
  	    samp = (*(data)&0xF0) + ((*(data+2) & 0xf0)>>4);
        period = (*(data)&0x0F)*256 + *(data+1);
        e1 = (*(data+2)) & 0x0F;
		    e2 = (*(data+3)  & 0xF0) >> 4;
		    e3 = (*(data+3)) & 0x0F;



        byte  = *(data);
  	    fprintf(output,"%c%c",hexchar[byte/16],hexchar[byte%16]);
        byte  = *(data+1);
  	    fprintf(output,"%c%c ",hexchar[byte/16],hexchar[byte%16]);
        byte  = *(data+2);
  	    fprintf(output,"%c%c",hexchar[byte/16],hexchar[byte%16]);
        byte  = *(data+3);
  	    fprintf(output,"%c%c ",hexchar[byte/16],hexchar[byte%16]);

        if(samp < 10) fprintf(output," %d ",samp);
        else fprintf(output,"%d ",samp);

        if(period < 10)       fprintf(output,"   %d ",period);
        else if(period <100)  fprintf(output,"  %d ",period);
        else if(period <1000) fprintf(output," %d ",period);
        else									fprintf(output,"%d ",period);

        if(e1 != 14) {
    	    //if(e1 < 10) fprintf(output," ( %d) ",e1);
    	    //else fprintf(output," (%d) ",e1);

          fprintf(output,"%s",effect_primary[e1]);
    	    for(k = 0; k < 11-strlen(effect_primary[e1]); k++) fprintf(output," ");

    	    //if(e2 < 10) fprintf(output," %d ",e2);
    	    //else fprintf(output,"%d ",e2);

          fprintf(output,"%c%c",hexchar[e2],hexchar[e3]);
    	    //if(e3 < 10) fprintf(output," %d ",e3);
    	    //else fprintf(output,"%d ",e3);
        }

        else {
    	    //if(e2 < 10) fprintf(output,"E( %d) ",e2);
    	    //else fprintf(output,"E(%d) ",e2);

          fprintf(output,"%s",effect_secondary[e2]);
    	    for(k = 0; k < 11-strlen(effect_secondary[e2]); k++) fprintf(output," ");

          fprintf(output," %c",hexchar[e3]);
    	    //if(e3 < 10) fprintf(output,"    %d ",e3);
    	    //else fprintf(output,"   %d ",e3);
        }
        fprintf(output,"/ ");
        data+=4;
      }
      fprintf(output,"\n");
    }
  }
}



/**************************************************************************
	void modstepper(void)

  DESCRIPTION:  Allows you to step through mod data to look for bugs. (doesn't
  						  actually play anything.)

**************************************************************************/
void modstepper(void)
{
	int flag = 1,i,linecounter=0;

  for(i = 0; i < 4; i++ ) {    // Reset all four channels
    chan[i].sdata = NULL;
    chan[i].offset = 0;
    chan[i].rlength = 0;
    chan[i].end = 0;
    chan[i].volume = 0;
    chan[i].sample_number = 0;
    chan[i].position= 0;
    chan[i].pos = (WORD *)(((BYTE *)&chan[i].position) +1);
    chan[i].counter = 0;
    chan[i].pinc = 0;
    chan[i].effect = 0;
    chan[i].x = 0;
    chan[i].y = 0;
  }
                                   // Reset global mod variables
  mod_pattern=mod_data->pattern_data[mod_data->ptable[0]];
  mod_pstop = mod_pattern+1024;
  mod_tablepos=0;
  mod_bytespertick = (WORD)(((long)sample_rate *220)/11000L);
  mod_ticksperdivision = 6;
  mod_currentbyte = 0;
  mod_currenttick = 0;
  mod_divoffset =0;

  mod_reset = FALSE;           // Reset the reset switch


	while(flag) {
    dodiv();                   // Handle the division commands.
                               // Are we at the end of the pattern?
    if(mod_pattern == mod_pstop) {
    	linecounter=0;
      mod_tablepos++;          // Next table!

                               // Done with tables?  Done with MOD.
      if(mod_tablepos == mod_data->num_positions) {

      	return;
      }

      else {                   // Otherwise, set pointer to next table
        mod_pattern = mod_data->pattern_data[mod_data->ptable[mod_tablepos]];
        mod_pstop = mod_pattern+1024;
      }
    }
    mod_currenttick = 0;       // Reset the tick counter
    for(i = 0; i < mod_ticksperdivision; i++) {
			dotick();
    }

    printf("Tablepos: %d\tLine: %d\n",mod_tablepos,linecounter++);
    //getch();
  }
}